<?php

/**
 * Automatich site index extension.
 *
 * $Id$
 * @package sws
 */

/**
 * Set index extension options. Called by the framework.
 *
 * No options are defined right now.
 * @access private
 */
function extIndexOptions()
{
}

/**
 * Sort a page array on title. Callback for {@link showIndex}.
 * @param array $a the page array to compare
 * @param array $b the page array to compare
 * @return int 0 if the page titles are equal, 1 if $a > $b, -1 if $a < $b
 * @access private
 */
function sortPage($a, $b)
{
	if (strtoupper($a['title']) > strtoupper($b['title'])) { return 1; }
	if (strtoupper($a['title']) > strtoupper($b['title'])) { return -1; }
	return 0;
}

/**
 * Show an index of site pages in alphabetical order.
 *
 * Won't show pages that have the option 'inindex' set to false.
 */
function showIndex()
{
	$db = db_get_object("sws");
	$res = $db->query("select * from pages where inindex = 1");
	$j = 0;
	for ($i = 0; $i < $res->num_rows(); $i++) {
		$pages[$j] = $res->fetch_array();
		if (!ereg("admin", $pages[$j]['url']))
			$j++;
	}

	usort($pages, "sortPage");

	$middle = sizeof($pages) / 2;
	$switched = 0;

	print "<table border=\"0\">\n";
	print "<tr>\n";
	print "<td valign=\"top\">\n";

	$prevletter = "0";
	for ($i = 0; $i < sizeof($pages); $i++) {
		$firstletter = strtolower(substr($pages[$i]['title'], 0, 1));
		if ($prevletter != $firstletter) {
			if ($prevletter != "0") {
				print "</ul>\n\n";
			}
			if (($i > $middle) && ($switched == 0)) {
				print "</td>\n";
				print "<td width=\"10%\">&nbsp;</td>\n";
				print "<td valign=\"top\">\n";
				$switched = 1;
			}

			print "<h1>" . strtoupper($firstletter) . "</h1>\n";
			print "<ul>\n";
			$prevletter = $firstletter;
		}

		print "<li><a href=\"" . $pages[$i]["url"] . "\">" .
		    $pages[$i]["title"] . "</a>\n";
	}

	print "</ul>\n";
	print "</td>\n";
	print "</tr>\n";
	print "</table>\n";
}

?>
