<?php

/**
 * Functions to manage the box inclusion code.
 *
 * $Id: boxes.php 594 2006-03-20 11:12:42Z stijn $
 * @package sws
 */

/**
 * Include the template for a specific box on a page.
 *
 * Themes must call addBox before they can use a box on a page.
 * @param string $name the name of the box
 * @param array $options the options for the box
 */
function addBox($name, $options = array())
{
	global $PAGE;

	$config = configPath();
	$dirs = $_SESSION["conf-$config"]['sws']['boxdirs'];
	for ($i = 0; $i < sizeof($dirs); $i++) {
		$dir = $dirs[$i] . $name . "/";
		if (file_exists($dir . "index.php")) {
			$PAGE['box' . $name]['name'] = $name;
			$PAGE['box' . $name]['dir'] = $dir;
			$PAGE['box' . $name]['url'] =
			    $_SESSION["conf-$config"]['sws']['boxurls'][$i] .
			    $name . "/";
			require($dir . "/index.php");
			eval("box" . $name . "Options(\$options);");
			break;
		}
	}

	// Error out if we couldn't find it
	if (!isset($PAGE['box' . $name]['name'])) {
		print "<p>No such box '$name' in box include path";
		exit;
	}
}

?>
