<?php

/**
 * SWS database classes for MySQL databases
 *
 * $Id: db_mysql.php 570 2006-01-03 09:07:50Z stijn $
 * @package sws
 */

/**
 * Class representing a query result for a MySQL database.
 * @package sws
 */
class db_mysql_result extends db_result
{
	/**
	 * Initializes a MySQL result class.
	 *
	 * Constructor for the class. This class is only meant to be
	 * instantiated by {@link db_mysql::query}.
	 * @access private
	 */
	function __construct($conn, $query, $ign)
	{
		parent::__construct($conn, $query, $ign);

		$this->result = @mysql_query($this->query, $this->conn);

		// Some rudimentary error checking
		if ($this->result === FALSE && !$this->ign) {
			if (debugging_on()) {
				err_backtrace(
				    "Invalid query: " . $this->query . "\n" .
				    "Error: " . mysql_error());
			} else {
				// XXX: figure out a good error mechanism
				print "A database error occurred.\n";
			}
			exit;
		} else {
			$err = mysql_error($this->conn);
			if ($err && debugging_on()) {
				err_backtrace(
				    "Query: " . $this->query . "\n" .
				    "Warning: " . $err . "\n");
			}
		}

		$this->aff = @mysql_affected_rows($conn);
	}

	function num_fields()  {
		return mysql_num_fields($this->result);
	}

	function num_rows()  {
		return mysql_num_rows($this->result);
	}

	function field_name($num)  {
		return mysql_field_name($this->result, $num);
	}

	function field_type($num)  {
		return mysql_field_type($this->result, $num);
	}

	function fetch_array($row = FETCH_NEXTROW, $method = FETCH_BOTH)  {
		if ($row == FETCH_NEXTROW)  {
			return mysql_fetch_array($this->result, $method);
		}

		mysql_data_seek($this->result, $row);
		return mysql_fetch_array($this->result, $method);
	}

	function free_result()
	{
		parent::free_result();
		return mysql_free_result($this->result);
	}

	function last_insert_id($table, $key)
	{
		//XXX: mysql only keeps a last insert id per connection,
		//     not per table/key
		return mysql_insert_id($this->conn);
	}
}

/**
 * Class representing a connection to a MySQL database.
 *
 * Not intended to be instantiated by end users; see {@link db_get_object}
 * for documentation about connecting to a database.
 * @package sws
 */
class db_mysql extends db
{
	function connect($host, $user, $passwd, $dbname, $port = null)
	{
		if (!isset($this->conn) || $this->conn == 0) {
			if (!function_exists("mysql_connect")) {
				return DB_NOT_SUPPORTED;
			}

			if (!is_null($port)) {
				$host = $host . ":" . $port;
			}

			$this->conn = @mysql_connect($host, $user, $passwd, 1);
			if (!$this->conn) {
				return DB_NOT_CONNECTED;
			}

			if (!@mysql_select_db($dbname, $this->conn)) {
				return DB_NOT_CONNECTED;
			}

			return DB_OK;
		}
	}

	function query($query)
	{
		parent::query($query);
		return new db_mysql_result($this->conn, $query, $this->ign);
	}

	function begin_transaction()
	{
		//XXX: mysql doesn't support transactions
		return false;
	}

	function commit()
	{
		//XXX: mysql doesn't support transactions
		return false;
	}

	function rollback()
	{
		//XXX: mysql doesn't support transactions
		return false;
	}

	function quote($str)
	{
		return "'" . mysql_escape_string($str) . "'";
	}

	function close()
	{
		return mysql_close($this->conn);
	}
}

?>
