<?php

/**
 * Functions to manage the extension inclusion code.
 *
 * $Id: extensions.php 594 2006-03-20 11:12:42Z stijn $
 * @package sws
 */

/**
 * Include the template for a specific extension on a page.
 *
 * Pages must call addExtension before they can use an extension.
 * @param string $name the name of the extension
 * @param array $options the options for the extension
 */
function addExtension($name, $options = array())
{
	global $PAGE;

	$config = configPath();
	$dirs = $_SESSION["conf-$config"]['sws']['extdirs'];
	for ($i = 0; $i < sizeof($dirs); $i++) {
		$dir = $dirs[$i] . $name . "/";
		if (file_exists($dir . "index.php")) {
			$PAGE['ext' . $name]['name'] = $name;
			$PAGE['ext' . $name]['dir'] = $dir;
			$PAGE['ext' . $name]['url'] =
			    $_SESSION["conf-$config"]['sws']['exturls'][$i] .
			    $name . "/";
			require($dir . "/index.php");
			eval("ext" . $name . "Options(\$options);");
			break;
		}
	}

	// Error out if we couldn't find it
	if (!isset($PAGE['ext' . $name]['name'])) {
		print "<p>No such extension '$name' in extension include path";
		exit;
	}
}

?>
