<?php

/**
 * Strip the HTML tags for user supplied input.
 *
 * $Id: striptags.php 495 2005-08-15 13:29:22Z stijn $
 * @package sws
 */

/**
 * Strip HTML tags from all user input.
 *
 * This function is used to counter attacks as described in CERT advisory
 * CA-2000-02: Malicious HTML Tags Embedded in Client Web Requests.
 *
 * The framework calls this function on every page request.
 */
function striptags()
{
	if (is_array($_POST)) {
		reset($_POST);
		while (list($key, $val) = each($_POST)) {
			if (is_string($_POST[$key])) {
				$_POST[$key] = strip_tags($val);
			}
		}
	}

	if (is_array($_GET)) {
		reset($_GET);
		while (list($key, $val) = each($_GET)) {
			if (is_string($_GET[$key])) {
				$_GET[$key] = strip_tags($val);
			}
		}
	}

	if (is_array($_COOKIE)) {
		reset($_COOKIE);
		while (list($key, $val) = each($_COOKIE)) {
			if (isset($_GET[$key]) && is_string($_GET[$key])) {
				$_GET[$key] = strip_tags($val);
			}
		}
	}

	if (is_array($_REQUEST)) {
		reset($_REQUEST);
		while (list($key, $val) = each($_REQUEST)) {
			if (is_string($_REQUEST[$key])) {
				$_REQUEST[$key] = strip_tags($val);
			}
		}
	}

	unset($HTTP_POST_VARS);
	unset($HTTP_GET_VARS);
	unset($HTTP_COOKIE_VARS);
	unset($HTTP_REQUEST_VARS);
	unset($HTTP_SESSION_VARS);
}

?>
