<?php

/**
 * Handles the change password procedure.
 *
 * $Id$
 * @package sws
 */

if (!loggedIn()) {
	requireLogin();
}

$db = db_get_sws_privileged_object();
if ($db === FALSE) {
	if (!onLoginHost()) {
		redirectLogin("password.php");
		exit;
	}

	print "configuration error: no privileged SWS access available";
	exit;
}

encryptProtocol();

if (!isset($_COOKIE['swschange'])) {
	if (isset($_GET['back']) && $_GET['back'] != "") {
		$backurl = $_GET['back'];
	} else {
		$backurl = defaultBackURL();
	}

	setLoginCookie('swschange', serialize($backurl));
	header("Location: " . stripQueryString(completeQualifiedMe()));
	exit;
}

// Check for bad cookies
$backurl = @unserialize($_COOKIE['swschange']);
if ($backurl === FALSE || !isset($backurl) || !is_string($backurl)) {
	session_regenerate_id();
	setLoginCookie('swschange', serialize(defaultBackURL()));
	needTheme();
	passwordChangeForm(PASSWORD_CHANGE);
	exit;
}

// Check if we have some POST data already
if (!isset($_POST['old']) || !isset($_POST['new']) ||
    !isset($_POST['verify'])) {
	session_regenerate_id();
	needTheme();
	passwordChangeForm(PASSWORD_CHANGE);
	exit;
}

// Check if the referrer for the posted data matches us -- not
// really a security check but it's one more obstacle to overcome
if (!matchReferrer()) {
	session_regenerate_id();
	needTheme();
	passwordChangeForm(PASSWORD_CHANGE);
	exit;
}

// Verify the posted data
$old = $_POST['old'];
$new = $_POST['new'];
$verify = $_POST['verify'];

$res = $db->query("SELECT password FROM users WHERE id = " . userId());
if (!$res || $res->num_rows() != 1) {
	session_regenerate_id();
	needTheme();
	passwordChangeForm(PASSWORD_CHANGE);
	exit;
}
$row = $res->fetch_array();
$realold = $row['password'];
$res->free_result();
	
if (md5($old) != $realold) {
	session_regenerate_id();
	needTheme();
	passwordChangeForm(PASSWORD_WRONG);
	exit;
}

if (md5($new) != md5($verify)) {
	session_regenerate_id();
	needTheme();
	passwordChangeForm(PASSWORD_MISMATCH);
	exit;
}
	
// Now update the password in the database
$res = $db->query("UPDATE users SET password = " .
    $db->quote(md5($new)) . " WHERE id = " . userId());
if (!$res) {
	session_regenerate_id();
	needTheme();
	passwordChangeForm(PASSWORD_CHANGE);
	exit;
}

// Done, clean up after ourselves
unsetLoginCookie('swschange');
setLoginCookie('swsdone', 'changepw');
header("Location: " . $backurl);

?>
