#
# $Id: Cfg.pm 398 2004-04-19 09:16:12Z stijn $
#
# SWS tool configuration parse functions.
#

package SWS::Cfg;

use strict;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK);

require Exporter;

@ISA = qw(Exporter);
@EXPORT = qw(
	parse_config
);
$VERSION = '0.5';

sub parse_config
{
	my ($path) = @_;

	my %rawconfig;
	open(CONFIG, $path) or die "Couldn't read configfile: $!";
	while (<CONFIG>) {
		chomp;			# no newline
		s/(^|\s+)#.*//;		# no comments
		s/^\s+//;		# no leading whitespace
		s/\s+$//;		# no trailing whitespace
		next unless length;	# anything left?
		my ($var, $value) = split(/\s*=\s*/, $_, 2);
		$value =~ s/^"//; $value =~ s/"$//;
		$rawconfig{$var} = $value;
	}
	close CONFIG;
	return %rawconfig;
}

1;
