#
# $Id: Root.pm 398 2004-04-19 09:16:12Z stijn $
#
# SWS functions for determining the root of the SWS installation, and
# the document root for the SWS installation.
#

package SWS::Root;

use strict;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK);

require Exporter;

@ISA = qw(Exporter);
@EXPORT = qw(
	swsroot
);
$VERSION = '0.5';

my $swsroot = "";

sub swsroot
{
	if (defined($swsroot) && $swsroot ne "") {
		return $swsroot;
	}

	# Find the root using the location of this include file.
	die("could not find SWS::Root path")
	    unless (defined($INC{'SWS/Root.pm'}));

	$swsroot = $INC{'SWS/Root.pm'};
	$swsroot =~ s!(.*)/tools/SWS/Root.pm!$1!;

	die("could not find SWS root directory")
	    unless (defined($swsroot) && $swsroot ne "");

	die("invalid SWS root directory $swsroot")
	    unless (-f "$swsroot/tools/checksetup");

	return $swsroot;
}

1;
